//TWO REPETITIONS
import java.util.*;
import java.io.*;

class main{

//Unfortunately "pif" files do not tell us how big the space is,
//so this needs to be hard coded :(
public static int sizeX=60;
public static int sizeY=40;
public static int sizeZ=1;  //use "1" for 2D!
public static int generations=250;
public static int popSize=500;
public static int repetitions=2;//how often an individual is run with different random seeds for avg. fitness to check robustness
public static java.util.Random rand=new java.util.Random();
public static int startGeneNo=20;
public static double mutationProb=0.01;
public static double crossoverProb=0.9;
public static int compPool=15;//for tournament selection
public static int elitism=1;
public static String baseDir=""; //not fixed here but given as parameter
public static String fixedSeed="23051981"; //not used here

//N.B.: The protBits here have to be the same as in the C++ code of course!!!
public static int protBits=4;
public static int maxProtNum=((int)Math.pow((double)2,(double)protBits));  //2^protBits  (i.e. 8 for three bits, but remember when to subtract one counting from zero)
public static int globalLength=25+protBits*maxProtNum;//length of the bits in every GRN genome coding for global variables

public static String[] mapInts=new String[]{"a","b","c","d","e","f","g","h","i","j","k","l","m","o","p","q","r","s","t","u","v","w","x","y","z"};

static class individual{

  int[] genome;
  double fitness;
  int id;

  individual(){fitness=99999999.0;id=-1;}

}

//more N.B.: 
//- "/" is used for sub-dirs, for use under Windows replace with "\"


//this is the exact XMLfile used to control CompuCell3D, only
//<RandomSeed>%RANDOMSEED%</RandomSeed>
//and
//<Genome>%GENOME%</Genome>
//are to be replaced with the actual values by the EA
//(of course linebreaks are marked with \r\n"+ ")
//N.B.:2nd line has to contain the genome and nothing else!
public static String XMLfile="<!--\r\n"+
"%GENOME%\r\n"+
"-->\r\n"+
"<CompuCell3D>\r\n"+
" <Potts>\r\n"+
"   <Dimensions x=\"60\" y=\"40\" z=\"1\"/>\r\n"+
"   <Anneal>0</Anneal>\r\n"+
"   <Steps>250</Steps>\r\n"+
"   <Temperature>2</Temperature>\r\n"+
"   <RandomSeed>%RANDOMSEED%</RandomSeed>\r\n"+
"   <Flip2DimRatio>1</Flip2DimRatio>\r\n"+
"   <FlipNeighborMaxDistance>1.75</FlipNeighborMaxDistance>\r\n"+
"<!--   <KBoltzmann>1.2</KBoltzmann> /-->\r\n"+
"<!--   <Offset>-0.1</Offset>        /-->\r\n"+
" </Potts>\r\n"+
"\r\n"+
" <Plugin Name=\"PlayerSettings\">\r\n"+
"\r\n"+
"    <!--Project2D XYProj=\"2\"/>\r\n"+
"    <InitialProjection Projection=\"xy\"/-->\r\n"+
"\r\n"+
"    <Rotate3D XRot=\"27\" YRot=\"-11\"/>\r\n"+
"    <VisualControl ZoomFactor=\"10\" ScreenshotFrequency=\"1001\" ScreenUpdateFreqeuncy=\"1\"/>\r\n"+
"    <Cell Type=\"1\" Color=\"blue\"/>\r\n"+
"    <Cell Type=\"2\" Color=\"white\"/>\r\n"+
"    <Cell Type=\"3\" Color=\"red\"/>\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Used as helper for other plugins /-->\r\n"+
" <Plugin Name=\"VolumeTracker\">\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Used as helper for other plugins /-->\r\n"+
" <Plugin Name=\"CenterOfMass\"/>\r\n"+
"\r\n"+
" <!-- Used as helper for other plugins /-->\r\n"+
" <Plugin Name=\"NeighborTracker\">\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Works in 2D only; keeps cells together in one piece (no fragments!) /-->\r\n"+
" <Plugin Name=\"Connectivity\">\r\n"+
"  <Penalty>1000000</Penalty>\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <Plugin Name=\"CellType\">\r\n"+
"    <CellType TypeName=\"Medium\" TypeId=\"0\"/>\r\n"+
"    <CellType TypeName=\"Blue\" TypeId=\"1\"/>\r\n"+
"    <CellType TypeName=\"White\" TypeId=\"2\"/>\r\n"+
"    <CellType TypeName=\"Red\" TypeId=\"3\"/>\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Target volume is set by GRN /-->\r\n"+
" <Plugin Name=\"VolumeLocalFlex\">\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Target volume is set by GRN /-->\r\n"+
" <Plugin Name=\"SurfaceLocalFlex\">\r\n"+
" </Plugin>\r\n"+
"\r\n"+
" <!-- Cadherin expression is done by GRN /-->\r\n"+
" <Plugin Name=\"ContactMultiCad\">\r\n"+
"   <Energy Type1=\"Medium\" Type2=\"Medium\">1</Energy>\r\n"+
"   <Energy Type1=\"Blue\" Type2=\"Blue\">-1</Energy>\r\n"+
"   <Energy Type1=\"White\"    Type2=\"White\">-1</Energy>\r\n"+
"   <Energy Type1=\"Red\"    Type2=\"Red\">-1</Energy>\r\n"+
"\r\n"+
"   <Energy Type1=\"Red\" Type2=\"Medium\">0</Energy>\r\n"+
"   <Energy Type1=\"White\"    Type2=\"Medium\">0</Energy>\r\n"+
"   <Energy Type1=\"Blue\"    Type2=\"Medium\">0</Energy>\r\n"+
"   <Energy Type1=\"White\"    Type2=\"Red\">0</Energy>\r\n"+
"   <Energy Type1=\"White\"    Type2=\"Blue\">0</Energy>\r\n"+
"   <Energy Type1=\"Blue\"    Type2=\"Red\">0</Energy>\r\n"+
"\r\n"+
"   <SpecificityCadherin>\r\n"+
"      <Specificity Cadherin1=\"Cad1\" Cadherin2=\"Cad1\">-20</Specificity>\r\n"+
"      <Specificity Cadherin1=\"Cad2\" Cadherin2=\"Cad2\">20</Specificity>\r\n"+
"      <Specificity Cadherin1=\"Cad1\" Cadherin2=\"Cad2\">0</Specificity>\r\n"+
"      <Specificity Cadherin1=\"Cad3\" Cadherin2=\"Cad3\">-5</Specificity>\r\n"+
"      <Specificity Cadherin1=\"Cad1\" Cadherin2=\"Cad3\">5</Specificity>\r\n"+
"      <Specificity Cadherin1=\"Cad2\" Cadherin2=\"Cad3\">5</Specificity>\r\n"+
"   </SpecificityCadherin>\r\n"+
"\r\n"+
"   <Depth>1.75</Depth>\r\n"+
"   <!--<Weight/>-->\r\n"+
"   <EnergyOffset>0.0</EnergyOffset>\r\n"+
"   <ContactFunctionType>linear</ContactFunctionType>\r\n"+
" </Plugin> \r\n"+
"\r\n"+
"<Plugin Name=\"CellShapeControl\">\r\n"+
"    <LambdaCellShapeControl>2000.0</LambdaCellShapeControl>\r\n"+
"</Plugin>\r\n"+
" <Plugin Name=\"Mitosis\">\r\n"+
"  <DoublingVolume>24</DoublingVolume>\r\n"+
" </Plugin>\r\n"+
"\r\n"+
"<!-- Activate this to update GRN dynamics or diffusion more than once per MCS\r\n"+
" <Plugin Name=\"PDESolverCaller\">\r\n"+
"  <CallPDE PDESolverName=\"FlexibleDiffusionSolverFE\" ExtraTimesPerMC=\"4\"/>\r\n"+
" </Plugin>\r\n"+
"/-->\r\n"+
"\r\n"+
" <Steppable Type=\"GRNcells\">\r\n"+
"	<Genome>%GENOME%</Genome>\r\n"+
" </Steppable>\r\n"+
"\r\n"+
" <!-- Secretion is controlled by GRN /-->\r\n"+
" <Steppable Type=\"FlexibleDiffusionSolverFE\">\r\n"+
"     <DiffusionField>\r\n"+
"        <DiffusionData>\r\n"+
"            <FieldName>SP1</FieldName>\r\n"+
"            <DiffusionConstant>0.2</DiffusionConstant>\r\n"+
"            <DecayConstant>0.009</DecayConstant>\r\n"+
"		    <!--ConcentrationFileName>diffusion_2D.pulse.txt</ConcentrationFileName-->\r\n"+
"		    <!--DoNotDecayIn>Medium</DoNotDecayIn/-->		\r\n"+
"        	    <!--<DoNotDiffuseTo>Amoeba</DoNotDiffuseTo>/-->\r\n"+
"            <ConcentrationThresholds MinConcentration=\"0.000001\" MaxConcentration=\"1.0\"/>\r\n"+
"        </DiffusionData>\r\n"+
"    </DiffusionField>\r\n"+
"     <DiffusionField>\r\n"+
"        <DiffusionData>\r\n"+
"            <FieldName>SP2</FieldName>\r\n"+
"            <DiffusionConstant>0.2</DiffusionConstant>\r\n"+
"            <DecayConstant>0.003</DecayConstant>\r\n"+
"            <ConcentrationThresholds MinConcentration=\"0.000001\" MaxConcentration=\"1.0\"/>\r\n"+
"        </DiffusionData>\r\n"+
"    </DiffusionField>\r\n"+
" </Steppable>\r\n"+
"\r\n"+
" <Steppable Type=\"PIFDumper\" Frequency=\"250\">\r\n"+
"  <PIFName>ttt</PIFName>\r\n"+
" </Steppable>\r\n"+
"\r\n"+
"<!--\r\n"+
" <Steppable Type=\"PIFInitializer\">\r\n"+
"    <PIFName>ttt.1000.pif</PIFName>\r\n"+
" </Steppable>\r\n"+
"-->\r\n"+
"\r\n"+
" <Steppable Type=\"BlobInitializer\">\r\n"+
"   <Gap>0</Gap>\r\n"+
"   <Width>1</Width>\r\n"+
"   <Radius>1</Radius>\r\n"+
"   <CellSortInit>no</CellSortInit>\r\n"+
" </Steppable>\r\n"+
"</CompuCell3D>";

//only does some replacing of placeholders
static String generateXMLfile(String genome, String seed){
String t=XMLfile.replace("%RANDOMSEED%",seed);
return t.replace("%GENOME%",genome);
}



static int comparePIFs(String originalFile,String differentFile) throws Exception{
	String[][][] original=readPIF(originalFile);
	String[][][] different=readPIF(differentFile);
	return comparePIFs(original,different);
}

static int comparePIFs(String[][][] original,String[][][] different) throws Exception{
boolean red=false;
boolean blue=false;
boolean white=false;
int ret=0;
for(int x=0;x<sizeX;x++)
        for(int y=0;y<sizeY;y++)
                for(int z=0;z<sizeZ;z++){
                        if((original[x][y][z]==null)&&(different[x][y][z]==null))
                                continue;

                        if((different[x][y][z]!=null)&&(different[x][y][z].compareTo("Red")==0))
                                red=true;
                        if((different[x][y][z]!=null)&&(different[x][y][z].compareTo("Blue")==0))
                                blue=true;
                        if((different[x][y][z]!=null)&&(different[x][y][z].compareTo("White")==0))
                                white=true;

                        if((original[x][y][z]==null)&&(different[x][y][z]!=null))
                                ret+=1;
                        if((original[x][y][z]!=null)&&(different[x][y][z]==null))
                                ret+=1;
                        if((original[x][y][z]!=null)&&(different[x][y][z]!=null)&&(original[x][y][z].compareTo(different[x][y][z])!=0))
                                ret+=1;
                        }

int cellTypes=0;
if(red) cellTypes++;
if(blue) cellTypes++;
if(white) cellTypes++;
return ret*(4-cellTypes);
}

static String[][][] readPIF(String filename) throws Exception{
String[][][] ret = new String[sizeX][sizeY][sizeZ];
int x1;
int x2;
int y1;
int y2;
int z1;
int z2;
File file = null;
BufferedReader pif =null;
String read ="";
              pif=new BufferedReader(
                    new FileReader(
                    filename));
read=pif.readLine();
while(read!=null){
//8	NonCondensing	12	12	19	19	0	0	
	String[] parts=read.split("\t");
	//System.out.println(read+" becomes: "+parts[1]+" "+parts[2]+" "+parts[3]+" "+parts[4]+" "+parts[5]+" "+parts[6]+" "+parts[7]);
	if(parts.length>=7){
		x1=Integer.parseInt(parts[2]);
		x2=Integer.parseInt(parts[3]);
		y1=Integer.parseInt(parts[4]);
		y2=Integer.parseInt(parts[5]);
		z1=Integer.parseInt(parts[6]);
		z2=Integer.parseInt(parts[7]);
		for(int x=x1;x<=x2;x++)
			for(int y=y1;y<=y2;y++)
				for(int z=z1;z<=z2;z++){
					ret[x][y][z]=parts[1];
					//System.out.println(x+" "+y+" "+z+" = "+parts[1]);
				}
		}
	read=pif.readLine();
	}

return ret;
}

public static String[] split(String what, String delim){
StringTokenizer x=new StringTokenizer(what,delim,true);
Vector y=new Vector();
//String[] ret=new String[x.countTokens()];
int max=x.countTokens();
String t;
int last=-1;
     for(int i=0;i<max;i++) {
         t=x.nextToken();
         if(t.equals(delim)){
           if(last==i-1){
             y.add("");
             }
           last=i;
           }
         else
           y.add(t);
     }
String[] ret=new String[y.size()];
     for(int i=0;i<ret.length;i++) {
         ret[i]=""+y.elementAt(i);
     }
return ret;
}


//int array to string conversion ({1,0,1}->"101")
public static String intArrToString(int[] in){
String ret="";
for(int i=0;i<in.length;i++)
  ret=ret+in[i];
return ret;
}

//string to int array conversion ("101"->{1,0,1})
public static int[] stringToIntArr(String in){
int[] ret=new int[in.length()];
for(int i=0;i<ret.length;i++)
  ret[i]=Integer.parseInt(""+in.charAt(i));
return ret;
}

public static int[] getRandomInd(){
int[] genome=new int[main.startGeneNo*(main.protBits+4+main.protBits)+main.globalLength];
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  genome[i]=next;
}
for(int i=0;i<main.startGeneNo;i++){
  genome[i*(4+main.protBits+main.protBits)+3+main.protBits+main.protBits]=3;
  genome[i*(4+main.protBits+main.protBits)+1+main.protBits]=2;
}
return genome;
}

/*returns offspring generated from input individuals*/
//HERE: from two parents two offspring are generated
public static int[][] getOffspring(int[][] parents){
int[] par1=parents[0];
int[] par2=parents[1];
String p1="";
String p2="";
String f1="";
String f2="";
p1=intArrToString(par1);
p2=intArrToString(par2);
//begin copying and maybe crossover

if(rand.nextDouble()>=crossoverProb){//no crossover
f1=p1;
f2=p2;
}
else{                                //do crossover
  //a crossover should always occur within the same compartment, i.e.
  //in the gene of the same number (although offset position might vary) or
  //in the part coding for global variables (offset may not vary - always same size)
  String[] splitGeno1=main.split(p1,""+3);
  String[] splitGeno2=main.split(p2,""+3);
  int crossoverComp=rand.nextInt(splitGeno1.length);
  if(splitGeno1[crossoverComp].length()<2) //should never happen....
    crossoverComp++;
  int offset;
 try{
  for(int i=0;i<splitGeno1.length;i++){
    if(crossoverComp==i){ //here it happens
      int crossoverPoint;
      if(splitGeno1[i].length()==0)
        crossoverPoint=0;
      else
        crossoverPoint=rand.nextInt(splitGeno1[i].length());
      if(crossoverComp==splitGeno1.length-1)
        offset=0;
      else
        offset=(int)(rand.nextGaussian()*4); //here it becomes interesting: the genome might become longer or shorter
      //do it for f1
      f1+=splitGeno1[i].substring(0,crossoverPoint);
      if(crossoverPoint+offset<0) //prevent IOErrors!
        offset=-crossoverPoint;
      if(!(crossoverPoint+offset>splitGeno2[i].length())) //prevent IOErrors!
        f1+=splitGeno2[i].substring(crossoverPoint+offset);

      //while(f1.length()-f1.lastIndexOf(""+3)<9) //prevent error: minimum length is 4
      //  f1+=rand.nextInt(2);

      //do it for f2
      if(crossoverPoint>splitGeno2[i].length()) //of course this might be shorter then splitGeno1[i], which is used for determining "crossoverPoint"
        crossoverPoint=splitGeno2[i].length();
      f2+=splitGeno2[i].substring(0,crossoverPoint);
      if(crossoverPoint-offset<0) //prevent IOErrors!
        offset=crossoverPoint;
      if(!(crossoverPoint-offset>splitGeno1[i].length())) //prevent IOErrors!
        f2+=splitGeno1[i].substring(crossoverPoint-offset);

      //while(f2.length()-f2.lastIndexOf(""+3)<9) //prevent error: minimum length is 4
      //  f2+=rand.nextInt(2);
    }
    else
      if(i<crossoverComp){
        f1+=splitGeno1[i];
        f2+=splitGeno2[i];
        }
      else{
        f1+=splitGeno2[i];
        f2+=splitGeno1[i];
        }
  if(i<splitGeno1.length-1){ //number of compartments stays the same always: number of genes plus the part coding for global variables
    f1+="3";
    f2+="3";
    }
  }//end for
 }//end try
 catch(Exception e){
  f1=p1;
  f2=p2;
  System.err.println("Error when crossing over the following genomes:\n"+p1+"\n\n"+p2+"\n\n"+e);
 }
}
//end copying and maybe crossover
int[] gene1=stringToIntArr(f1);
int[] gene2=stringToIntArr(f2);
//begin maybe mutation
for(int i=0;i<gene1.length;i++){
  if((gene1[i]<2)&&(rand.nextDouble()<=mutationProb)){
    if(gene1[i]==0)
      gene1[i]=1;
    else
      gene1[i]=0;
    }
  }
for(int i=0;i<gene2.length;i++){
  if((gene2[i]<2)&&(rand.nextDouble()<=mutationProb)){
    if(gene2[i]==0)
      gene2[i]=1;
    else
      gene2[i]=0;
    }
  }
//end maybe mutation

return new int[][]{gene1,gene2};
}

public static String getSeed(){
int ret=rand.nextInt();
if(ret<0) ret*=-1;
return ""+ret;
//return ""+fixedSeed; //use this line for always the same seed!
}

public static void initialGen(String dirName){
File idir = null;
File xmlFile = null;
PrintWriter out = null;

try{//make directory
  idir = new File(dirName);
  idir.mkdirs();}
catch(Exception e){System.err.println("COULD NOT MAKE DIR "+dirName);System.exit(1);}
try{
for(int i=0;i<popSize;i++){
 String rIndividual=intArrToString(getRandomInd());
 for(int j=0;j<repetitions;j++)
  {
  xmlFile=new File(dirName+"/"+i+mapInts[j]+".xml");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(xmlFile)));
  out.println(generateXMLfile(rIndividual,getSeed()));
  out.close();
  }
 }
}
catch(Exception e){
  System.err.println("Error creating xml files!\n"+e);
}

//this final section is for the production of cluster control files only -
//you might not need it if you do computations locally etc.
makeClusterBundles(dirName);

}

/*returns howMany randomly drawn individuals of current population*/
/*NB: an indivdual might be included several times!*/
public static individual[] getPartPopulation(individual[] currentPop, int howMany){
individual[] ret=new individual[howMany];
for(int i=0;i<howMany;){
  ret[i]=currentPop[rand.nextInt(currentPop.length)];
   if(ret[i].fitness<9999999998.0)
     i++;
}
return ret;
}

public static individual getFittest(individual[] pop){
double fit=9999999999.0;
int pos=-1;
for(int i=0;i<pop.length;i++)
  if((pop[i]!=null)&&(pop[i].fitness<fit)){
    fit=pop[i].fitness;
    pos=i;
    }
if(pos>=0)
  return pop[pos];
else
  return null;
}

public static individual get2ndFittest(individual[] pop){
individual fit=getFittest(pop);
individual[] temp=new individual[pop.length-1];
for(int i=0;i<pop.length-1;i++)
  if(pop[i]!=fit) /*omit fittest, add all others*/
    temp[i]=pop[i];
return getFittest(temp);
}

public static String leadingZeros(int length, int number){
String ret=""+number;
while(ret.length()<length){
  ret="0"+ret;
}
return ret;
}

  private static void copyfile(String srFile, String dtFile){
    try{
      File f1 = new File(srFile);
      File f2 = new File(dtFile);
      InputStream in = new FileInputStream(f1);
      
      OutputStream out = new FileOutputStream(f2);

      byte[] buf = new byte[1024];
      int len;
      while ((len = in.read(buf)) > 0){
        out.write(buf, 0, len);
      }
      in.close();
      out.close();
      System.out.println("File "+srFile+"copied to "+dtFile);
    }
    catch(FileNotFoundException ex){
      System.err.println(ex.getMessage() + " in the specified directory.");
    }
    catch(IOException e){
      System.out.println(e.getMessage());      
    }
  }

public static individual getLastElite(String newDirName, String currDirName, String lastDirName, int lastGenNum){
File ldir = null;
BufferedReader xmldata =null;
String read ="";
individual[] pop=new individual[popSize];
try{//scan old directory
 ldir = new File(lastDirName);
 for(int i=0;i<popSize;i++){
  try{
   xmldata=new BufferedReader(
    new FileReader(lastDirName+"/"+i+"a.xml"));
  read=xmldata.readLine();
  read=xmldata.readLine();//second line has to contain genome!!!
  pop[i]=new individual();
  pop[i].genome=stringToIntArr(read);
  pop[i].fitness=0;
  for(int j=0;j<repetitions;j++)
   pop[i].fitness+=comparePIFs("target.pif",lastDirName+"/"+i+mapInts[j]+".pif");
  pop[i].fitness/=(repetitions*1.0);
  pop[i].id=i;
  }catch(Exception e){
   //file not found
  pop[i]=new individual();
  pop[i].genome=getRandomInd();
  pop[i].fitness=9999999998.0;
  pop[i].id=i;
  }
 }
individual ret=getFittest(pop);
  //should be for all repetitions!!!
copyfile(lastDirName+"/"+ret.id+"a.pif",newDirName+"/"+ret.id+"a.pif");
copyfile(lastDirName+"/"+ret.id+"a.xml",newDirName+"/"+ret.id+"a.xml");
return ret;
}
catch(Exception e){
  System.err.println(" Could not find elite!");
  individual i=new individual();
  i.genome=getRandomInd();
  i.fitness=9999999998.0;
  return i;

 }
}

public static void nextGen(String lastDirName, int lastGenNum){
int currGen=lastGenNum+1;
if(currGen>=generations){ //we're done here
  System.out.println("Maximum number of generations reached, run finished");
  return;}
File ldir = null;
BufferedReader xmldata =null;
String read ="";
individual[] pop=new individual[popSize];
try{//scan old directory
 ldir = new File(lastDirName);
 for(int i=0;i<popSize-1;i++){
  try{
   xmldata=new BufferedReader(
    new FileReader(lastDirName+"/"+i+"a.xml"));
  read=xmldata.readLine();
  read=xmldata.readLine();//second line has to contain genome!!!
  pop[i]=new individual();
  pop[i].genome=stringToIntArr(read);
  pop[i].fitness=0;
  for(int j=0;j<repetitions;j++)
   pop[i].fitness+=comparePIFs("target.pif",lastDirName+"/"+i+mapInts[j]+".pif");
  pop[i].fitness/=(repetitions*1.0);
  }catch(Exception e){
   //file not found
  pop[i]=new individual();
  pop[i].genome=getRandomInd();
  pop[i].fitness=9999999998.0;
  }
 }
}
catch(Exception e){System.err.println("(FILE) ERROR IN "+lastDirName+e);System.exit(1);}

//make new directory
File idir = null;
String newDir="gen"+leadingZeros((generations+"").length(),currGen);
try{//make directory
  idir = new File(newDir);
  idir.mkdirs();}
catch(Exception e){System.err.println("COULD NOT MAKE DIR "+newDir);System.exit(1);}

if(lastGenNum-1>=0){
  pop[popSize-1]=getLastElite(newDir,lastDirName,"gen"+leadingZeros((generations+"").length(),(lastGenNum-1)),(lastGenNum-1));
System.out.println("Last Elite: "+pop[popSize-1].fitness);
}
else{
  pop[popSize-1]=new individual();
  pop[popSize-1].genome=getRandomInd();
  pop[popSize-1].fitness=9999999998.0;
}

//prepare for elitism 
int count=popSize;
int[][] nextPop=new int[popSize][];
individual[] popCopy=new individual[popSize];
for(int i=0;i<pop.length;i++)
  popCopy[i]=pop[i];

//intermezzo: output results for human inspection
File resultsFile = null;
PrintWriter out = null;
try{
 resultsFile=new File(lastDirName+"/results.txt");
 out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(resultsFile)));
 individual fitstar=getFittest(popCopy);
 out.println("Best fitness: "+fitstar.fitness+"\r\n");
 for(int i=0;i<popSize;i++){
  out.println(i+"\r\n"+intArrToString(pop[i].genome)+"\r\n"+pop[i].fitness+"\r\n");
  }
 out.close();
}
catch(Exception e){
  System.err.println("Error creating xml files!\n"+e);
}

//now all data should be written, we are ready to generate the next population
//begin elitism
for(int i=0;i<elitism;i++){
  individual fit=getFittest(popCopy);
  nextPop[--count]=fit.genome;
  for(int j=0;j<popCopy.length;j++)
    if(popCopy[j]==fit) //kick this guy out so elitism doesn't pick him again!
      popCopy[j]=null;
}//end elitism
//now fill up with crossover'ed individuals
int[][] parents=new int[2][];
int[][] offspring;
while(count>0){
  individual[] maybeParents=getPartPopulation(pop,compPool);
  parents[0]=(getFittest(maybeParents)).genome;
  parents[1]=(get2ndFittest(maybeParents)).genome;
  offspring=getOffspring(parents);
  nextPop[--count]=offspring[0];
  if(count>0)
    nextPop[--count]=offspring[1];
  }

File xmlFile = null;
//PrintWriter
 out = null;

try{
for(int i=0;i<popSize;i++)
 for(int j=0;j<repetitions;j++)
  {
  xmlFile=new File(newDir+"/"+i+mapInts[j]+".xml");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(xmlFile)));
  out.println(generateXMLfile(intArrToString(nextPop[i]),getSeed()));
  out.close();
  }
}
catch(Exception e){
  System.err.println("Error creating xml files!\n"+e);
}

//this final section is for the production of cluster control files only -
//you might not need it if you do computations locally etc.
makeClusterBundles(newDir);
}

public static String translateRep(int i){
int individual=(i/repetitions);
int repetition=(i%repetitions);
return individual+mapInts[repetition];
}

public static void makeClusterBundles(String newDir){
//assumes everything is already in the directory, esp. xml files!
File batFile = null;
PrintWriter out = null;
File condorFile = null;

int bundleSize=20;//this EA writes cluster processing files, bundleSize is the number of individuals put into one job
int currBundleSize=0;
int currBundle=0;
try{
for(int i=0;i<(popSize*repetitions);i++){
  if(batFile==null){
   batFile=new File(newDir+"/"+baseDir+currBundle+".bat");
   out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(batFile)));
   out.println("ttt.exe\r\necho ttt.exe unpacked");
  }
  out.println("call job.bat "+translateRep(i));
  currBundleSize++;
  if((currBundleSize>=bundleSize)||(i+1==(popSize*repetitions))){
   out.close();
   batFile=null;
   currBundle++;
   currBundleSize=0;
  }
 }
out.close();
}
catch(Exception e){
  System.err.println("Error creating clusterBundle bat files!\n"+e);
}

currBundleSize=0;
currBundle=0;
try{
for(int i=0;i<(popSize*repetitions);i++){
  if(condorFile==null){
   condorFile=new File(newDir+"/run"+currBundle+".condor");
   out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(condorFile)));
   out.print("universe       = Vanilla\r\n"+
	"executable     = "+baseDir+currBundle+".bat\r\n"+
	"transfer_input_files=../ttt.exe,");
  }
  out.print(translateRep(i)+".xml,");
  currBundleSize++;
  if((currBundleSize>=bundleSize)||(i+1==(popSize*repetitions))){
   out.println("../job.bat\r\n"+
	"Requirements   = OpSys == \"WINNT51\"\r\n"+
	"should_transfer_files = YES\r\n"+
	"when_to_transfer_output = ON_EXIT_OR_EVICT\r\n"+
	"output         = test.out.part"+currBundle+"\r\n"+
	"error          = test.err.part"+currBundle+"\r\n"+
	"log            = "+currBundle+".log\r\n"+
	"arguments      = "+currBundle+"\r\n"+
	"getenv = true\r\n"+
	"queue 1");
   out.close();
   condorFile=null;
   currBundle++;
   currBundleSize=0;
  }
 }
}
catch(Exception e){
  System.err.println("Error creating clusterBundle bat files!\n"+e);
}


}

public static void main(String[] args){
/*String[][][] original=readPIF("frenchFlag.pif");
String[][][] different=readPIF("frenchFlag.pif");
different[39][23][0]=null;
int result=comparePIFs(original,different);
System.out.println(generateXMLfile("test1","test2"));
*/
if(args.length==2){ //arguments should be baseDir and the last generation
  System.out.println("Here is main, arg: "+args[0]+" "+args[1]);
  baseDir=args[0];
  String gen=args[1].substring(3);
  nextGen(args[1],Integer.parseInt(gen));
}else
 if(args.length==1){ 
 //one argument, so we start a new run from generation 0
  System.out.println("Here is main, arg "+args[0]);
  baseDir=args[0];
  initialGen("gen"+leadingZeros((generations+"").length(),0));
 }else
   System.err.println("One or two parameters expected: baseDir [generationDir]");

} 

}
